unit FractalU;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.ComCtrls, system.UITypes;

type
  TFormFractal = class(TForm)
    Panel1: TPanel;
    ButtonClose: TButton;
    ButtonClear: TButton;
    ButtonDraw1: TButton;
    EditLevel: TEdit;
    UpDownLevel: TUpDown;
    ButtonDraw2: TButton;
    ButtonDraw3: TButton;
    ButtonDraw4: TButton;
    ButtonDraw5: TButton;
    CheckBox1: TCheckBox;
    ButtonDraw6: TButton;
    ButtonDraw7: TButton;
    ButtonDraw8: TButton;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Label1: TLabel;
    procedure ButtonClearClick(Sender: TObject);
    procedure ButtonDraw1Click(Sender: TObject);
    procedure ButtonCloseClick(Sender: TObject);
    procedure ButtonDraw2Click(Sender: TObject);
    procedure ButtonDraw3Click(Sender: TObject);
    procedure ButtonDraw4Click(Sender: TObject);
    procedure ButtonDraw5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonDraw6Click(Sender: TObject);
    procedure ButtonDraw7Click(Sender: TObject);
    procedure ButtonDraw8Click(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
  private
    { Private 錾 }
    XNow, YNow: extended; // ݂̈
  public
    { Public 錾 }
    procedure StandBy(X, Y: Integer);       // o_w肷B
    procedure Move(Muki, Kyori: extended);  // Muki  Kyori i
    procedure Line(Muki, Kyori: extended);  // Muki  Kyori 
    procedure Koch(Level: Byte; Muki, Nagasa: extended);
    procedure DrawKoch(Level: Byte);
    procedure KochThree(Level: Byte);
    procedure Sierpinski;
    procedure DrawTriangle(aCanvas: TCanvas; x, y, size: extended; n: byte);
    procedure drawTree(g: TCanvas; a, b: Tpoint ;n: byte);
    procedure drawDragon(g: TCanvas; a, b: TPoint; n: byte);
    procedure makeTree(ax, ay, bx, by : smallInt; depth : byte);
  end;

var
  FormFractal: TFormFractal;

implementation

{$R *.dfm}

uses system.Math, system.Types;

var waittime : integer;

//------------------------------- Pythagoras tree -----------------------------------
// http://www.davdata.nl/math/pythtree.html
procedure TFormFractal.makeTree(ax, ay, bx, by : smallInt; depth : byte);
var
  cx, cy, dx, dy, ex, ey : smallInt;
  x, y, zx, zy : smallInt;
begin
  x := bx - ax;
  y := ay - by;
  cx := ax - y;
  cy := ay - x;
  dx := bx - y;
  dy := by - x;
  zx := (cx + dx) div 2;
  zy := (cy + dy) div 2;
  ex := zx - (y div 2);
  ey := zy - (x div 2);
  with Canvas do
  begin
    pen.color := $FF0000 + depth;   // hԂ𐳂s߂̃yFݒ
    pen.width := 1;
    moveto(bx, by);                 // lp``
    lineto(ax, ay);
    lineto(cx, cy);
    lineto(dx, dy);
    lineto(bx, by);
    ax := (cx + bx) div 2;          // hԂN_W
    ay := (cy + by) div 2;
    brush.Color := depth * 256 * 16 + $FF;    // hԂF
    FloodFill(ax, ay, pen.Color, fsBorder);
    if depth > 0 then
    begin
      maketree(cx, cy, ex, ey, depth - 1);
      maketree(ex, ey, dx, dy, depth - 1);
    end;
  end;
  if waittime > 0 then begin
    sleep(waittime);
    application.ProcessMessages;
  end;
end;

//------------------------------- Dragon --------------------------------------------
procedure TFormFractal.drawDragon(g: TCanvas; a, b: TPoint; n: byte);
var
  c : TPoint;
  xx, yy: integer;
begin
  xx := b.x - a.x;
  yy := -(b.y - a.y);
  c.x := round(a.x + (xx + yy) / 2);
  c.y := round(b.y + (xx + yy) / 2);
  //ŌȂ̂ŁAۂɐ܂
  if n <= 0 then begin
    g.MoveTo(a.x, a.y);  //_A_C
    g.LineTo(c.x, c.y);
    g.LineTo(b.x, b.y);  //_c_b
  end
  //Ōł͂Ȃ̂ŁAɃ\bhĂяo܂iċAj
  else begin
    drawDragon(g, a, c, n - 1);    //_A_C
    drawDragon(g, b, c, n - 1);    //_B_C
  end;
  if waittime > 0 then begin
    sleep(waittime);
    application.ProcessMessages;
  end;
end;

//------------------------------- Tree ----------------------------------------------
procedure TFormFractal.drawTree(g: TCanvas; a, b: TPoint ;n: byte);
const
  STEM_RATIO = 0.25;
  BRANCH_RATIO = 0.6;
var
  c, d, e: Tpoint;
  xsign, xx, yy : integer;
  angle1, angle2, center_length, branch_length: double;
begin
  xx := b.x - a.x;
  yy := -(b.y - a.y);
  if xx <> 0 then begin
    angle1 := arctan(yy / xx) + PI / 3;
    angle2 := arctan(yy / xx) - PI / 3;
  end
  else begin
    angle1 := Pi / 2 + PI / 3;
    angle2 := Pi / 2 - PI / 3;
  end;

  center_length := sqrt(xx * xx + yy * yy) * (1 - STEM_RATIO);
  branch_length := BRANCH_RATIO * center_length;

  //̒EȂ畄}CiXɂ܂
  if xx >= 0 then xsign := 1 else xsign := -1;
  c.x := round((a.x + STEM_RATIO * xx));
  c.y := round((a.y - STEM_RATIO * yy));
  d.x := c.x + xsign * round((branch_length * cos(angle1)));
  d.y := c.y - xsign * round((branch_length * sin(angle1)));
  e.x := c.x + xsign * round((branch_length * cos(angle2)));
  e.y := c.y - xsign * round((branch_length * sin(angle2)));
  //͍̕ċAsȂ̂ŁA_A_C֎ۂɐ܂
  g.MoveTo(a.x, a.y);
  g.LineTo(c.x, c.y);
  //ŌȂ̂ŁAۂɐ܂
  if n <= 1 then begin
    g.MoveTo(c.x, c.y);
    g.LineTo(b.x, b.y); //i_C_Bցj
    g.MoveTo(c.x, c.y);
    g.LineTo(d.x, d.y); //̎}i_C_Dցj
    g.MoveTo(c.x, c.y);
    g.LineTo(e.x, e.y); //E̎}i_C_Eցj
  end
  //Ōł͂Ȃ̂ŁAXɃ\bhĂяo܂iċAj
  else begin
    n := n - 1;
    drawTree(g, c, b, n);   //i_C_Bցj
    drawTree(g, c, d, n);   //̎}i_C_Dցj
    drawTree(g, c, e, n);   //E̎}i_C_Eցj
  end;
  if waittime > 0 then begin
    sleep(waittime);
    application.ProcessMessages;
  end;
end;

//------------------------------- tN^Op` -----------------------------------------
procedure TFormFractal.DrawTriangle(aCanvas: TCanvas; x, y, size: extended; n: byte);
var
  h: extended;
  w: extended;
  x1, x2, x3, y1, y2, y3: extended;
  px1, px2, px3: integer;
  py1, py2: integer;

  procedure Triangle(xp, yp: extended);   // Op`
  begin
    px1 := Round(xp);                     //   x
    px2 := Round(xp + w * 2);             //  E x@
    px3 := Round(xp + w);                 // _ x
    py1 := Round(yp);                     //  y
    py2 := Round(yp - h);                 // _ y@
    aCanvas.MoveTo(px1, py1);
    aCanvas.LineTo(px2, py1);
    aCanvas.LineTo(px3, py2);
    aCanvas.LineTo(px1, py1);
  end;

begin
// Op`R`
  w := size;
  h := size * 1.5744;
  // left
  x1 := x;
  y1 := y;
  Triangle(x1, y1);
  // right
  x2 := x1 + w * 2;
  y2 := y1;
  Triangle(x2, y2);
  // top
  x3 := x2 - w;
  y3 := y2 - h;
  Triangle(x3, y3);
// ċA`
  if n > 1 then
  begin
    dec(n);
    size := size / 2;
    DrawTriangle(aCanvas, x1, y1, size, n);
    DrawTriangle(aCanvas, x2, y2, size, n);
    DrawTriangle(aCanvas, x3, y3, size, n);
  end;
  if waittime > 0 then begin
    sleep(waittime);
    application.ProcessMessages;
  end;
end;

//--------------------------- VFsXL[̃MXPbg -------------------
procedure TFormFractal.Sierpinski;
var
  i, count, x, y: integer;
  xcoord, ycoord: array[0..2] of integer;
begin
  xcoord[0] := 275;           // Op`̒_X
  ycoord[0] := 40;            // Op`̒_y
  xcoord[1] := 40;            // Op`̒Ӎx
  ycoord[1] := 410;           // Op`̒Ӎy
  xcoord[2] := 510;           // Op`̒ӉEx
  ycoord[2] := 410;           // Op`̒ӉEy
  x := 40;                    // lx
  y := 410;                   // ly

  for count:= 0 to 10000 do
  begin
    i := random(3);                 // 0`2 łȂƐ}`͕\܂
    x := (x + xcoord[i]) div 2;
    y := (y + ycoord[i]) div 2;
    case i of
      0: canvas.pixels[x,y] := clred;
      1: canvas.pixels[x,y] := clgreen;
      2: canvas.pixels[x,y] := clblue;
    end;
  end;
end;

//------------------------- RbzȐ ------------------------------------------
procedure TFormFractal.StandBy(X, Y: Integer);
begin
  Canvas.MoveTo(X, Y);
  XNow := X;
  YNow := Y;
end;

procedure TFormFractal.Move(Muki, Kyori: extended);
begin
  XNow := XNow + Kyori * Cos(Muki);
  YNow := YNow + Kyori * Sin(Muki);
  Canvas.MoveTo(Round(XNow), Round(YNow));
end;

procedure TFormFractal.Line(Muki, Kyori: extended);
begin
  XNow := XNow + Kyori * Cos(Muki);
  YNow := YNow + Kyori * Sin(Muki);
  Canvas.LineTo(Round(XNow), Round(YNow));
end;

procedure TFormFractal.Koch(Level: Byte; Muki, Nagasa: extended);
begin
  if Level <= 1 then Line(Muki,Nagasa)        // ۂɐ
  else begin                                  //  1/3CLevel-1 RbzȐ`
    Koch(Level-1, Muki, Nagasa / 3);          // wɕ`
    Koch(Level-1, Muki - Pi / 3, Nagasa / 3); //  60 Kɕ`
    Koch(Level-1, Muki + Pi / 3, Nagasa / 3); // E 60 Kɕ`
    Koch(Level-1, Muki, Nagasa / 3);          // wɕ`
  end;
end;

procedure TFormFractal.DrawKoch(Level: Byte);
begin
  StandBy(50, 250);     // n_
  Koch(Level, 0, 400);  // RbzȐ
end;

procedure TFormFractal.KochThree(Level: Byte);
var
  Leveled: byte;
begin
  canvas.Pen.Color := clBlack;
  Leveled := Level and $0F;
  if Level and $80 = 0 then begin         // Op
    Koch(Leveled, 0, 300);                // RbzȐ
    Koch(Leveled,pi * 2 / 3 * 2, 300);    // RbzȐ
    Koch(Leveled,pi * 2 / 3,     300);    // RbzȐ
  end
  else begin                              // OOp
    Koch(Leveled, 0, 300);                // RbzȐ
    Koch(Leveled,-pi * 2 / 3 * 2, 300);   // RbzȐ
    Koch(Leveled,-pi * 2 / 3,     300);   // RbzȐ
    Canvas.Brush.Color := clBlue;
    Canvas.FloodFill(250 , 220, clBlack, fsBorder);
  end;
end;

//-------------------------------------------------------------------------------
procedure TFormFractal.ButtonDraw1Click(Sender: TObject);
var
  Level:  byte;
begin
  ButtonDraw1.Enabled := False;
  if checkbox1.Checked = true then ButtonClearClick(nil);
  Level := UpDownLevel.Position;
  DrawKoch(Level);
  ButtonDraw1.Enabled := True;
end;

procedure TFormFractal.ButtonDraw2Click(Sender: TObject);
var
  Level:  byte;
begin
  ButtonDraw2.Enabled := False;
  if checkbox1.Checked = true then ButtonClearClick(nil);
  Level := UpDownLevel.Position;
  StandBy(100, 300);      // n_
  KochThree(Level);
  ButtonDraw2.Enabled := True;
end;

procedure TFormFractal.ButtonDraw3Click(Sender: TObject);
var
  Level:  byte;
begin
  ButtonDraw3.Enabled := False;
  if checkbox1.Checked = true then ButtonClearClick(nil);
  Level := UpDownLevel.Position;
  StandBy(100, 120);        // n_
  KochThree(Level or $80);  // Op`}tOZbg
  ButtonDraw3.Enabled := True;
end;

procedure TFormFractal.ButtonDraw4Click(Sender: TObject);
var
  Level :  byte;
  i     :  byte;
begin
  ButtonDraw4.Enabled := False;
  if checkbox1.Checked = true then ButtonClearClick(nil);
  Level := UpDownLevel.Position;
  for i := 1 to Level do Sierpinski;
  ButtonDraw4.Enabled := True;
end;

procedure TFormFractal.ButtonDraw5Click(Sender: TObject);
var
  Level :  byte;
  size : extended;
  x,y : extended;
begin
  ButtonDraw5.Enabled := False;
  if checkbox1.Checked = true then ButtonClearClick(nil);
  Level := UpDownLevel.Position;
  size := 117.5;
  x := 40;
  y := 410;
  Canvas.Pen.Color := clFuchsia;
  DrawTriangle(Canvas, x, y, size, Level);
  ButtonDraw5.Enabled := True;
end;

procedure TFormFractal.ButtonDraw6Click(Sender: TObject);
var
  Level :  byte;
  B, T: Tpoint;
begin
  ButtonDraw6.Enabled := False;
  if checkbox1.Checked = true then ButtonClearClick(nil);
  Level := UpDownLevel.Position;
  //R΂̓_w肵܂
  B := Point(250, 400);
  T := Point(250, 50);
  //ꂼ̑΂ȂQ_ԂɎ؋Ȑ`܂
  canvas.Pen.Color := clBlue;
  drawTree(canvas, B, T, Level);
  ButtonDraw6.Enabled := True;
end;

procedure TFormFractal.ButtonDraw7Click(Sender: TObject);
var
  Level :  byte;
  B, T: Tpoint;
begin
  ButtonDraw7.Enabled := False;
  if checkbox1.Checked = true then ButtonClearClick(nil);
  Level := UpDownLevel.Position;
  //o_ƂȂ΂̓_w肵܂
  B := Point(220, 100);
  T := Point(430, 310);
  //΂ƂȂ_̊ԂɃhSȐ`܂
  canvas.Pen.Color := clBlue;
  drawDragon(canvas, B, T, Level);
  ButtonDraw7.Enabled := True;
end;

procedure TFormFractal.ButtonDraw8Click(Sender: TObject);
var
  Level :  byte;
begin
  ButtonDraw8.Enabled := False;
  if checkbox1.Checked = true then ButtonClearClick(nil);
  Level := UpDownLevel.Position;
  // ŏ̎lp`̒ӂ̍Ww肵܂
  makeTree(250, 400, 330, 400, Level);
  ButtonDraw8.Enabled := True;
end;

procedure TFormFractal.ButtonClearClick(Sender: TObject);
begin
  with Canvas do
  begin
    Brush.Color := clBtnface;
    FillRect(ClipRect);
  end;
end;

procedure TFormFractal.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  Waittime := updown1.Position * 10;
end;

procedure TFormFractal.ButtonCloseClick(Sender: TObject);
begin
  close;
end;

procedure TFormFractal.FormCreate(Sender: TObject);
begin
  Clientheight := 500;
  ClientWidth := 743;
end;

end.
